<template>
  <ObModal
    ref="modal"
    :title-second="titleSecond"
    :title="title"
    size="large"
  >
    <ob-form
      class="contract-service-form"
      :form-data="formData"
      :form-model="formModel"
      :is-read-only="!isDraft"
      data-qa="serviceForm"
      @submit="onSubmitHandler"
      :dropdown-menu="dropdownMenu"
      :ok-text="isNew ? 'Добавить' : 'Сохранить'"
      cancel-text="Отменить"
    >
      <ObSelect
        ref="serviceSelect"
        v-if="isNew"
        v-model="formData.uuid"
        label="Услуга"
        placeholder="Выберите из списка"
        :display-func="(data) => `${data.title}. ${data.subtitle}`"
        :remote-opt="{
          method: api.contract.getServices,
          loadEvent: 'open',
          arguments: {
            uuid: contract.uuid,
            caste: 'MULTISTOP'
          }
        }"
        :is-search="true"
        property="uuid"
        class="mb20"
        data-qa="service"
        @selected="selectedService"
      />
      <p
        v-else
        class="mb20"
      >
        {{ dataSource.serviceTypeTitle }}. {{ dataSource.resourceSpeciesTitle }}. {{ dataSource.resourceSubtypeTitle }}. {{ dataSource.resourcePatternParameter }}. {{ dataSource.serviceUnitTitle }}
      </p>
      <div class="sub-title">
        <span>Налог на добавленную стоимость (НДС)</span>
        <ObTooltip content="НДС">
          <i class="icon question" />
        </ObTooltip>
      </div>
      <ObRadio
        v-model="formData.isNds"
        label="Не облагается НДС"
        :valueInput="false"
        class="mb10"
        data-qa="isNotNds"
        :disabled="isVatPayer"
        @change="clearNds"
      />
      <ObRadio
        v-model="formData.isNds"
        label="Облагается НДС"
        :valueInput="true"
        class="mb10"
        :disabled="!isVatPayer"
        data-qa="isNds"
        @change="setDefaultNds"
      />
      <transition name="toggle-height">
        <div
          class="checkbox-input"
          :class="isNew && 'ml25'"
        >
          <template v-if="formData.vatType !== 'NO_VAT'">
            <ObInput
              v-model="formData.vatRate"
              label="Величина НДС"
              sub-title="%"
              placeholder="Укажите"
              class="input-nds"
              type="number:strict"
              :readonly="true"
              data-qa="vatValue"
            />
            <ObCheckbox
              v-model="formData.isVatInclude"
              label="Тарифы указываются с учетом НДС"
              data-qa="isVatInclude"
              :disabled="!isDraft"
            />
          </template>
          <template v-if="formData.vatType === 'NO_VAT' && !isNew">
            Не облагается НДС
          </template>
        </div>
      </transition>
      <div class="nds-row mt20">
        <i class="icon alert" />
        <span>Настройки НДС будут применены ко всем маршрутам этой услуги</span>
      </div>
    </ob-form>
  </ObModal>
</template>

<script>
  import { mapGetters } from 'vuex'
  import api from '@/api'
  import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
  import models from '@/models'
  import cloneDeep from 'clone-deep'
  import ObForm from 'common-components/src/obComponents/obForm'
  import ObInput from 'common-components/src/obComponents/obInput'
  import ObRadio from 'common-components/src/obComponents/obRadio'
  import ObSelect from 'common-components/src/obComponents/obSelect'
  import ObCheckbox from 'common-components/src/obComponents/obCheckbox'
  import ObTooltip from 'common-components/src/obComponents/obTooltip'
  import ObModal from 'common-components/src/obComponents/obModal'

  export default {
    name: 'ContractTransportationMultistopServiceModal',
    components: {
      ObSelect,
      ObInput,
      ObForm,
      ObCheckbox,
      ObRadio,
      ObTooltip,
      ObModal
    },
    mixins: [
      FormValidationMixin
    ],
    props: {
      title: {
        type: String,
        default: ''
      },
      titleSecond: {
        type: String,
        default: ''
      }
    },
    data () {
      return {
        api,
        isNds: true
      }
    },
    computed: {
      ...mapGetters({
        contract: 'contract/contract',
        isDraft: 'contract/isDraft',
        isVatPayer: 'contract/isDoerVatPayer'
      }),
      disabledKeyWords() {
        return this.isNew ? false : !this.dataSource.is_active
      },
      isNew() {
        return !this.dataSource || !this.dataSource.uuid
      },
      formModel() {
        if (this.isNew) {
          return models.contract.serviceMultistop({ isVatPayer: this.isVatPayer })
        } else {
          return models.contract.serviceMultistopEdit({ isVatPayer: this.isVatPayer })
        }
      },
      dropdownMenu () {
        if (this.isNew || !this.isDraft) {
          return []
        } else {
          return [
            {
              title: 'Удалить услугу',
              className: 'menu-button-danger',
              method: this.deleteService
            }
          ]
        }
      }
    },
    methods: {
      afterInitForm () {
        if (this.$refs.serviceSelect) {
          this.$refs.serviceSelect.firstLoad = true
        }
      },
      open () {
        this.$refs.modal.open()
      },
      close () {
        this.$refs.modal.close()
      },
      onSubmitHandler () {
        let data = cloneDeep(this.formData)
        delete data.serviceUnits

        this.$emit('submit', {formData: data, model: this.formModel})
      },
      clearNds () {
        this.formData.vatValue = null
        this.formData.isVatInclude = true
      },
      setDefaultNds () {
        this.formData.vatValue = this.isVatPayer ? 20 : null
      },
      selectedService (item) {
        this.formData.contractUuid = this.$route.query.id
        this.formData.serviceDictUuid = item.serviceDictUuid
        this.formData.serviceUnitUuid = item.serviceUnits && item.serviceUnits[0] && item.serviceUnits[0].uuid
        this.formData.serviceUnits = item.serviceUnits
        this.formData.resourceTypeUuid = item.resourceTypeUuid
        let data = item.serviceUnits
        data.map((i)=>{i.label = i.title})
        this.serviceUnits = data
      },
      deleteService () {
        this.$emit('on-delete', { ...this.dataSource })
      }
    }
  }
</script>

<style lang='scss' scoped>
  @import '~common-components/src/static/css/mixins';

  .contract-service-form {
    .main-title {
      @include font-mixin(20px, 28px, 600, $color-text-base, 0.4px);
    }

    .sub-title {
      margin-bottom: 10px;
      @include font-mixin(16px, 24px, 600, $color-text-base, 0.4px);
      .icon {
        margin-left: 3px;
        font-size: 14px;
        font-weight: bold;
        color: $color-grey-span;
      }
    }

    .tariff-input {
      width: 193px;
    }
  }
</style>

<style lang="scss" scoped>
  .contract-service-form {
    .menu-button-danger {
      button {
        color: $color-error;
      }
    }

    .mt20 {
      margin-top: 20px!important;
    }

    .mb20 {
      margin-bottom: 20px;
    }

    .mb10 {
      margin-bottom: 10px;
    }

    .mb30 {
      margin-bottom: 30px!important;
    }

    .ml25 {
      margin-left: 25px;
    }

    .checkbox-input {
      display: flex;
      justify-content: flex-start;
      align-items: center;

      .ob-checkbox-container {
        flex-shrink: 0;
        margin-left: 20px;
      }
    }

    .input-nds {
      width: 145px;
    }

    .nds-row {
      width: 100%;
      display: flex;
      align-items: center;
      padding: 20px;
      background-color: $color-white-lilac;
      .icon {
        font-size: 24px;
        color: $color-blue-navy-blue;
      }
      span {
        padding-left: 5px;
        font-size: 14px;
        line-height: 20px;
        color: $color-text-base;
        &:first-of-type {
          padding-left: 20px;
        }
      }
    }
  }
</style>
